/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package tree;

import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.NoSuchElementException;

public class TreeV3<E> implements Collection<E> {

    private Node<E>[] tree;

    public Node<E>[] getTree(){
      return this.tree;
    }

    public TreeV3(Node<E>[] tree) {
        this.tree = tree;
    }

    public void clear(){
      this.tree = null;
    }

    public int getLevel(int e){
      return tree[e].children.length;
    }

    public boolean retainAll(Collection c){
      throw new UnsupportedOperationException();
    }

    public boolean remove(Object o) {
      if (!(o instanceof Node)) {
        return false;
      }
      Node node = (Node) o;
      removeNode(node);
      for (int i = 0; i < node.children.length; i++){
        remove(node.children[i]);
      }
      return true;
    }

    protected void removeNode(Node<E> node) {
        int index = findNodeIndex(node, this.tree);
        Node<E>[] newNode = new Node[this.tree.length - 1];
        for (int j = 0; j < index; j++) {
            newNode[j] = this.tree[j];
        }

        for (int j = index; j < this.tree.length; j++) {
            newNode[j] = this.tree[j];
        }

        this.tree = newNode;
    }



    public boolean removeAll(Collection c){
      try{
        Object[] array = c.toArray();
        for (int i = 0; i < array.length; i++) {
          this.remove(array[i]);
        }
        return true;
      }
      catch(Exception e){
        return false;
      }
    }

    public boolean add(E node) {
      if (!(node instanceof Node)) {
        return false;
      }
      Node<E> root = null;
      Node[] newNodes = new Node[this.tree.length + 1];
      for (int i = 0; i < tree.length; i++) {
        newNodes[i] = tree[i];
        if (tree[i].isRoot()) {
          root = tree[i];
        }
      }
      if (root != null) {
        newNodes[newNodes.length - 1] = (Node<E>) node;
        Node[] newChildren = new Node[root.children.length + 1];
        for (int i = 0; i < root.children.length; i++) {
          newChildren[i] = root.children[i];
        }
        newChildren[newChildren.length - 1] = (Node<E>) node;
        root.children = newChildren;
        node.parent = root;
        return true;
      }
      return false;
   }

    public boolean addAll(Collection c){
      try {
        for (Object i : c) {
            this.add((E)i);
        }
        return true;
      } catch(Exception e) {
        return false;
      }
    }

    public boolean containsAll(Collection c) {
      for (Object i : c) {
        if (!contains(i)) {
          return false;
        }
      }
      return true;
    }

    public Node<E>[] toArray(Object[] o){
      if(isEmpty()){
        throw new NoSuchElementException();
      }
      else{
        return this.tree;
     }
    }

    public Node<E>[] toArray(){
        return this.tree;
    }

    public boolean contains(Object o){
      for(int i = 0; i < tree.length; i++) {
        if(tree[i] == o){
          return true;
        }
      }
      return false;
    }

    public boolean isEmpty(){
      return size() == 0;
    }

    public int size(){
      return this.tree.length;
    }

    protected int findNodeIndex(Node<E> o, Node<E>[] node){
      for(int index = 0; index < node.length; index++){
        if(o == node[index]){
          return index;
        }
      }
      return -1;
    }

    // public boolean equals(Object o){
    //   if (o == tree[i]) return true;
    //   if(o == null || tree[i].getClass() != o.getClass()){
    //     return false;
    //   }
    //   return tree[i] == o;
    // }


    public boolean equals(Object obj) {
        return isEquals(obj);
    }

    protected boolean isEquals(Object obj){
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        Node other = (Node) obj;
        if (children == null) {
            if (other.children != null) {
                return false;
            }
        } else if (!children.equals(other.children)) {
            return false;
        }
        if (data == null) {
            if (other.data != null) {
                return false;
            }
        } else if (!data.equals(other.data)) {
            return false;
        }
        return true;
    }

    public Iterator iterator(){
      return new MyIterator(myNodes);
    }
  }
